fun boolToInteger(true) = 1 | boolToInteger(false)=0;
Define `inv_FFS_Status (inv_param:num)  = T`;
BasicProvers.export_rewrites(["inv_FFS_Status_def"]);
BasicProvers.export_rewrites(["inv_FFS_Status_def"]);
Define `inv_FS_OpenMode (inv_param:num)  = T`;
BasicProvers.export_rewrites(["inv_FS_OpenMode_def"]);
BasicProvers.export_rewrites(["inv_FS_OpenMode_def"]);
Define `inv_FS_AccessMode (inv_param:num)  = T`;
BasicProvers.export_rewrites(["inv_FS_AccessMode_def"]);
BasicProvers.export_rewrites(["inv_FS_AccessMode_def"]);
Hol_datatype `FFS_VolumeInfo = <| totalFragments:num;  totalAvailableFragments:num;  totalInvalidFragments:num;  fragmentGranularity:num |>`;
Define `make_FFS_VolumeInfo (totalFragments_recConstrParam:num) (totalAvailableFragments_recConstrParam:num) (totalInvalidFragments_recConstrParam:num) (fragmentGranularity_recConstrParam:num)  = <|totalFragments:=totalFragments_recConstrParam; totalAvailableFragments:=totalAvailableFragments_recConstrParam; totalInvalidFragments:=totalInvalidFragments_recConstrParam; fragmentGranularity:=fragmentGranularity_recConstrParam|>`;
BasicProvers.export_rewrites(["make_FFS_VolumeInfo_def"]);
Define `FFS_VolumeInfo_field_1 (record:FFS_VolumeInfo)  = record.totalFragments`;
BasicProvers.export_rewrites(["FFS_VolumeInfo_field_1_def"]);
Define `FFS_VolumeInfo_field_2 (record:FFS_VolumeInfo)  = record.totalAvailableFragments`;
BasicProvers.export_rewrites(["FFS_VolumeInfo_field_2_def"]);
Define `FFS_VolumeInfo_field_3 (record:FFS_VolumeInfo)  = record.totalInvalidFragments`;
BasicProvers.export_rewrites(["FFS_VolumeInfo_field_3_def"]);
Define `FFS_VolumeInfo_field_4 (record:FFS_VolumeInfo)  = record.fragmentGranularity`;
BasicProvers.export_rewrites(["FFS_VolumeInfo_field_4_def"]);
BasicProvers.export_rewrites(["FFS_VolumeInfo_field_4_def", "FFS_VolumeInfo_field_3_def", "FFS_VolumeInfo_field_2_def", "FFS_VolumeInfo_field_1_def", "make_FFS_VolumeInfo_def"]);
Define `inv_FFS_VolumeInfo (inv_param:FFS_VolumeInfo)  = T`;
BasicProvers.export_rewrites(["inv_FFS_VolumeInfo_def"]);
BasicProvers.export_rewrites(["inv_FFS_VolumeInfo_def"]);
Hol_datatype `FFS_Format = <| fragmentGranularity:num;  fragmentOverheadPerBlock:num |>`;
Define `make_FFS_Format (fragmentGranularity_recConstrParam:num) (fragmentOverheadPerBlock_recConstrParam:num)  = <|fragmentGranularity:=fragmentGranularity_recConstrParam; fragmentOverheadPerBlock:=fragmentOverheadPerBlock_recConstrParam|>`;
BasicProvers.export_rewrites(["make_FFS_Format_def"]);
Define `FFS_Format_field_1 (record:FFS_Format)  = record.fragmentGranularity`;
BasicProvers.export_rewrites(["FFS_Format_field_1_def"]);
Define `FFS_Format_field_2 (record:FFS_Format)  = record.fragmentOverheadPerBlock`;
BasicProvers.export_rewrites(["FFS_Format_field_2_def"]);
BasicProvers.export_rewrites(["FFS_Format_field_2_def", "FFS_Format_field_1_def", "make_FFS_Format_def"]);
Define `inv_FFS_Format (inv_FFS_Format_subj:FFS_Format)  = (let ffs_format = inv_FFS_Format_subj in ((((ffs_format.fragmentGranularity  = 1024 )  \/ (ffs_format.fragmentGranularity  = 2048 ) )  \/ (ffs_format.fragmentGranularity  = 4096 ) )  \/ (ffs_format.fragmentGranularity  = 8192 ) ))`;
BasicProvers.export_rewrites(["inv_FFS_Format_def"]);
BasicProvers.export_rewrites(["inv_FFS_Format_def"]);
Hol_datatype `Root = RootQuoteLiteral`;
Define `inv_Root (inv_param:Root)  = T`;
BasicProvers.export_rewrites(["inv_Root_def"]);
BasicProvers.export_rewrites(["inv_Root_def"]);

Hol_datatype `Path =  RootQuoteLiteral | AList of ((char list) list)`;
(*
Hol_datatype `Path =  RootQuoteLiteral | ((char list) list)`;
*)

Define `inv_Path (inv_Path_subj: Path) = 
  let path = inv_Path_subj in 
  ~(path = RootQuoteLiteral) ==> ~(path = AList [])`;
(*
Define `inv_Path (inv_Path_subj: RootQuoteLiteral | ((char list) list) )  = (let path = inv_Path_subj in (((\x y . ~ (x = y)) path RootQuoteLiteral)  ==> ((\x y . ~ (x = y)) path []) ))`;
*)

BasicProvers.export_rewrites(["inv_Path_def"]);
BasicProvers.export_rewrites(["inv_Path_def"]);
Define `inv_FileName (inv_FileName_subj:(char list))  = (let fileName = inv_FileName_subj in ((\x y . ~ (x = y)) fileName []))`;
BasicProvers.export_rewrites(["inv_FileName_def"]);
BasicProvers.export_rewrites(["inv_FileName_def"]);
Hol_datatype `RegularFile = RegularFileQuoteLiteral`;
Define `inv_RegularFile (inv_param:RegularFile)  = T`;
BasicProvers.export_rewrites(["inv_RegularFile_def"]);
BasicProvers.export_rewrites(["inv_RegularFile_def"]);
Hol_datatype `Directory = DirectoryQuoteLiteral`;
Define `inv_Directory (inv_param:Directory)  = T`;
BasicProvers.export_rewrites(["inv_Directory_def"]);
BasicProvers.export_rewrites(["inv_Directory_def"]);
Hol_datatype `FileType =  RegularFileQuoteLiteral | DirectoryQuoteLiteral `;
Define `inv_FileType (inv_param:FileType)  = T`;
BasicProvers.export_rewrites(["inv_FileType_def"]);
BasicProvers.export_rewrites(["inv_FileType_def"]);
Hol_datatype `Attributes = <| fileType:FileType |>`;
Define `make_Attributes (fileType_recConstrParam:FileType)  = <|fileType:=fileType_recConstrParam|>`;
BasicProvers.export_rewrites(["make_Attributes_def"]);
Define `Attributes_field_1 (record:Attributes)  = record.fileType`;
BasicProvers.export_rewrites(["Attributes_field_1_def"]);
BasicProvers.export_rewrites(["Attributes_field_1_def", "make_Attributes_def"]);
Define `inv_Attributes (inv_param:Attributes)  = T`;
BasicProvers.export_rewrites(["inv_Attributes_def"]);
BasicProvers.export_rewrites(["inv_Attributes_def"]);

Hol_datatype `FileContents = BList of ((char list) list)`;
Hol_datatype `File = <| attributes:Attributes;  contents:FileContents |>`;
(*
Hol_datatype `File = <| attributes:Attributes;  contents:((char list) list) |>`;
*)

Define `make_File (attributes_recConstrParam:Attributes) (contents_recConstrParam:FileContents)  = <|attributes:=attributes_recConstrParam; contents:=contents_recConstrParam|>`;
(*
Define `make_File (attributes_recConstrParam:Attributes) (contents_recConstrParam:((char list) list))  = <|attributes:=attributes_recConstrParam; contents:=contents_recConstrParam|>`;
*)

BasicProvers.export_rewrites(["make_File_def"]);
Define `File_field_1 (record:File)  = record.attributes`;
BasicProvers.export_rewrites(["File_field_1_def"]);
Define `File_field_2 (record:File)  = record.contents`;
BasicProvers.export_rewrites(["File_field_2_def"]);
BasicProvers.export_rewrites(["File_field_2_def", "File_field_1_def", "make_File_def"]);

Define `inv_File (inv_File_subj:File) = 
  let file = inv_File_subj in 
  ((file.attributes.fileType  = DirectoryQuoteLiteral)    /\ (file.contents = BList []))  \/ 
  ((file.attributes.fileType  = RegularFileQuoteLiteral)  /\ (~(file.contents = (BList []))))`;
(*
Define `inv_File (inv_File_subj:File)  = (let file = inv_File_subj in (((file.attributes.fileType  = DirectoryQuoteLiteral )  /\ (file.contents  = [] ) )  \/ ((file.attributes.fileType  = RegularFileQuoteLiteral )  /\ ((\x y . ~ (x = y)) file.contents []) ) ))`;
*)

BasicProvers.export_rewrites(["inv_File_def"]);
BasicProvers.export_rewrites(["inv_File_def"]);
Define `inv_FileContents (inv_param:(char list))  = T`;
BasicProvers.export_rewrites(["inv_FileContents_def"]);
BasicProvers.export_rewrites(["inv_FileContents_def"]);
Define `inv_FS_FileHandle (inv_param:num)  = T`;
BasicProvers.export_rewrites(["inv_FS_FileHandle_def"]);
BasicProvers.export_rewrites(["inv_FS_FileHandle_def"]);
Hol_datatype `FS_OpenFileInfo = <| accessMode:num;  modified:bool;  sizeChanged:bool;  path:Path |>`;
Define `make_FS_OpenFileInfo (accessMode_recConstrParam:num) (modified_recConstrParam:bool) (sizeChanged_recConstrParam:bool) (path_recConstrParam:Path)  = <|accessMode:=accessMode_recConstrParam; modified:=modified_recConstrParam; sizeChanged:=sizeChanged_recConstrParam; path:=path_recConstrParam|>`;
BasicProvers.export_rewrites(["make_FS_OpenFileInfo_def"]);
Define `FS_OpenFileInfo_field_1 (record:FS_OpenFileInfo)  = record.accessMode`;
BasicProvers.export_rewrites(["FS_OpenFileInfo_field_1_def"]);
Define `FS_OpenFileInfo_field_2 (record:FS_OpenFileInfo)  = record.modified`;
BasicProvers.export_rewrites(["FS_OpenFileInfo_field_2_def"]);
Define `FS_OpenFileInfo_field_3 (record:FS_OpenFileInfo)  = record.sizeChanged`;
BasicProvers.export_rewrites(["FS_OpenFileInfo_field_3_def"]);
Define `FS_OpenFileInfo_field_4 (record:FS_OpenFileInfo)  = record.path`;
BasicProvers.export_rewrites(["FS_OpenFileInfo_field_4_def"]);
BasicProvers.export_rewrites(["FS_OpenFileInfo_field_4_def", "FS_OpenFileInfo_field_3_def", "FS_OpenFileInfo_field_2_def", "FS_OpenFileInfo_field_1_def", "make_FS_OpenFileInfo_def"]);
Define `inv_FS_OpenFileInfo (inv_param:FS_OpenFileInfo)  = T`;
BasicProvers.export_rewrites(["inv_FS_OpenFileInfo_def"]);
BasicProvers.export_rewrites(["inv_FS_OpenFileInfo_def"]);
Hol_datatype `System = <| table:((num, FS_OpenFileInfo) fmap);  fileStore:((Path, File) fmap) |>`;
Define `make_System (table_recConstrParam:((num, FS_OpenFileInfo) fmap)) (fileStore_recConstrParam:((Path, File) fmap))  = <|table:=table_recConstrParam; fileStore:=fileStore_recConstrParam|>`;
BasicProvers.export_rewrites(["make_System_def"]);
Define `System_field_1 (record:System)  = record.table`;
BasicProvers.export_rewrites(["System_field_1_def"]);
Define `System_field_2 (record:System)  = record.fileStore`;
BasicProvers.export_rewrites(["System_field_2_def"]);
BasicProvers.export_rewrites(["System_field_2_def", "System_field_1_def", "make_System_def"]);
Define `inv_System (inv_System_subj:System)  = (let sys = inv_System_subj in (!  uni_0_var_1.((((uni_0_var_1  IN (FRANGE sys.table) )  /\ (?  ofi.(ofi  = uni_0_var_1 )) )  /\ T )  ==> (let ofi = uni_0_var_1 in (ofi.path  IN (FDOM sys.fileStore) )) )))`;
BasicProvers.export_rewrites(["inv_System_def"]);
BasicProvers.export_rewrites(["inv_System_def"]);
Define `inv_OpenFilesTable (inv_param:((num, FS_OpenFileInfo) fmap))  = T`;
BasicProvers.export_rewrites(["inv_OpenFilesTable_def"]);
BasicProvers.export_rewrites(["inv_OpenFilesTable_def"]);
Define `pre_blast (blast_parameter_1:((char list) list))  = (let S = blast_parameter_1 in ((\x y . ~ (x = y)) S []))`;
BasicProvers.export_rewrites(["pre_blast_def"]);

Define `(reverseOrder [] = []) /\ 
        (reverseOrder (h::t) = $++(reverseOrder(t)) ([h]))`;
(*
Define `reverseOrder (reverseOrder_parameter_1:((char list) list)) = 
  (let S = reverseOrder_parameter_1 in 
   (if ((LENGTH S)  = 0 ) 
    then [] 
    else (let h = (HD S) and t = (TL S) in 
          ($++ (reverseOrder t) [h]))))`;
*)

BasicProvers.export_rewrites(["reverseOrder_def"]);
Define `blast (blast_parameter_1:((char list) list))  = (let S = blast_parameter_1 in (reverseOrder (TL (reverseOrder S))))`;
BasicProvers.export_rewrites(["blast_def"]);

Define `dirName (path:Path)
  = case path of
        RootQuoteLiteral  -> RootQuoteLiteral
     || (AList fileNames) -> if LENGTH fileNames > 1
	                         then AList (blast fileNames)
						     else RootQuoteLiteral`;
(*
Define `dirName (dirName_parameter_1:Path) = 
  (let full_path = dirName_parameter_1 in 
   
    then RootQuoteLiteral
  else (let S = full_path in (blast S))))`;
*)

BasicProvers.export_rewrites(["dirName_def"]);
Define `inv_FileStore (inv_FileStore_subj:((Path, File) fmap))  = (let fileStore = inv_FileStore_subj in (!  uni_1_var_1.((((uni_1_var_1  IN (FDOM fileStore) )  /\ (?  path.(path  = uni_1_var_1 )) )  /\ T )  ==> (let path = uni_1_var_1 in (let parent = (dirName path) in ((parent  IN (FDOM fileStore) )  /\ ((FAPPLY fileStore parent).attributes.fileType  = DirectoryQuoteLiteral ) ))) )))`;
BasicProvers.export_rewrites(["inv_FileStore_def"]);
BasicProvers.export_rewrites(["inv_FileStore_def"]);
Define `isDirectory (isDirectory_parameter_1:File)  = (let file = isDirectory_parameter_1 in (file.attributes.fileType  = DirectoryQuoteLiteral ))`;
BasicProvers.export_rewrites(["isDirectory_def"]);
Define `isRegularFile (isRegularFile_parameter_1:File)  = (let file = isRegularFile_parameter_1 in (file.attributes.fileType  = RegularFileQuoteLiteral ))`;
BasicProvers.export_rewrites(["isRegularFile_def"]);

(*
Define `hasContents (hasContents_parameter_1:File) = 
  let file = hasContents_parameter_1 in 
  ~(file.contents = (BList [])) /\ 
  ~((HD ((\(BList x) . x) file.contents)) = [])`;

BasicProvers.export_rewrites(["hasContents_def"]);
*)

Define `hasSubFiles (hasSubFiles_parameter_1:((Path, File) fmap)) (hasSubFiles_parameter_2:Path)  = (let fileStore = hasSubFiles_parameter_1 and path = hasSubFiles_parameter_2 in (?  exi_2_var_1.((((exi_2_var_1  IN (FDOM fileStore) )  /\ (?  subpath.(subpath  = exi_2_var_1 )) )  /\ T )  /\ (let subpath = exi_2_var_1 in (path  = (dirName subpath) )) )))`;
BasicProvers.export_rewrites(["hasSubFiles_def"]);
Define `isRoot (isRoot_parameter_1:Path)  = (let path = isRoot_parameter_1 in (path  = RootQuoteLiteral ))`;
BasicProvers.export_rewrites(["isRoot_def"]);
Define `isElemFileStore (isElemFileStore_parameter_1:Path) (isElemFileStore_parameter_2:((Path, File) fmap))  = (let path = isElemFileStore_parameter_1 and fileStore = isElemFileStore_parameter_2 in (path  IN (FDOM fileStore) ))`;
BasicProvers.export_rewrites(["isElemFileStore_def"]);


Define `isElemTablePath (isElemTable_parameter_1:Path) (isElemTable_parameter_2:((num, FS_OpenFileInfo) fmap))  = (let path = isElemTable_parameter_1 and table = isElemTable_parameter_2 in (?  exi_3_var_1.((((exi_3_var_1  IN (FRANGE table) )  /\ (?  ofd.(ofd  = exi_3_var_1 )) )  /\ T )  /\ (let ofd = exi_3_var_1 in (ofd.path  = path )) )))`;
BasicProvers.export_rewrites(["isElemTablePath_def"]);
Define `isElemTableHandle (isElemTable_parameter_1:num) (isElemTable_parameter_2:((num, FS_OpenFileInfo) fmap))  = (let handle = isElemTable_parameter_1 and table = isElemTable_parameter_2 in (handle  IN (FDOM table) ))`;
BasicProvers.export_rewrites(["isElemTableHandle_def"]);
(*
Define `isElemTable (isElemTable_parameter_1:Path) (isElemTable_parameter_2:((num, FS_OpenFileInfo) fmap))  = (let path = isElemTable_parameter_1 and table = isElemTable_parameter_2 in (?  exi_3_var_1.((((exi_3_var_1  IN (FRANGE table) )  /\ (?  ofd.(ofd  = exi_3_var_1 )) )  /\ T )  /\ (let ofd = exi_3_var_1 in (ofd.path  = path )) )))`;
BasicProvers.export_rewrites(["isElemTable_def"]);
Define `isElemTable (isElemTable_parameter_1:num) (isElemTable_parameter_2:((num, FS_OpenFileInfo) fmap))  = (let handle = isElemTable_parameter_1 and table = isElemTable_parameter_2 in (handle  IN (FDOM table) ))`;
BasicProvers.export_rewrites(["isElemTable_def"]);
*)

Define `isDirName (isDirName_parameter_1:Path) (isDirName_parameter_2:Path)  = (let parent = isDirName_parameter_1 and path = isDirName_parameter_2 in (parent  = (dirName path) ))`;
BasicProvers.export_rewrites(["isDirName_def"]);
Define `emptyFileContents (emptyFileContents_parameter_1:FileType)  = (let fileType = emptyFileContents_parameter_1 in (if (fileType  = DirectoryQuoteLiteral ) then [] else [[]]))`;
BasicProvers.export_rewrites(["emptyFileContents_def"]);
Define `FS_DeleteFileDir_FileStore (FS_DeleteFileDir_FileStore_parameter_1:((Path, File) fmap)) (FS_DeleteFileDir_FileStore_parameter_2:(Path set))  = (let fileStore = FS_DeleteFileDir_FileStore_parameter_1 and paths = FS_DeleteFileDir_FileStore_parameter_2 in ((\x y . DRESTRICT y (COMPL x)) paths fileStore))`;
BasicProvers.export_rewrites(["FS_DeleteFileDir_FileStore_def"]);
Define `FS_DeleteFileDir_System (FS_DeleteFileDir_System_parameter_1:System) (FS_DeleteFileDir_System_parameter_2:Path)  = (let sys = FS_DeleteFileDir_System_parameter_1 and full_path = FS_DeleteFileDir_System_parameter_2 in (sys with <|fileStore:=(FS_DeleteFileDir_FileStore sys.fileStore {full_path})|>))`;
BasicProvers.export_rewrites(["FS_DeleteFileDir_System_def"]);
Define `pre_FS_DeleteFileDir_FileStore (FS_DeleteFileDir_FileStore_parameter_1:((Path, File) fmap)) (FS_DeleteFileDir_FileStore_parameter_2:(Path set))  = (let fileStore = FS_DeleteFileDir_FileStore_parameter_1 and paths = FS_DeleteFileDir_FileStore_parameter_2 in (!  uni_5_var_1.((((uni_5_var_1  IN (FDOM fileStore) )  /\ (?  path.(path  = uni_5_var_1 )) )  /\ T )  ==> (let path = uni_5_var_1 in (((dirName path)  IN paths )  ==> (path  IN paths ) )) )))`;
BasicProvers.export_rewrites(["pre_FS_DeleteFileDir_FileStore_def"]);
Define `pre_FS_DeleteFileDir_System (FS_DeleteFileDir_System_parameter_1:System) (FS_DeleteFileDir_System_parameter_2:Path)  = (let sys = FS_DeleteFileDir_System_parameter_1 and full_path = FS_DeleteFileDir_System_parameter_2 in ((!  uni_4_var_1.((((uni_4_var_1  IN (FRANGE sys.table) )  /\ (?  ofi.(ofi  = uni_4_var_1 )) )  /\ T )  ==> (let ofi = uni_4_var_1 in ((\x y . ~ (x = y)) ofi.path full_path)) ))  /\ (pre_FS_DeleteFileDir_FileStore sys.fileStore {full_path}) ))`;
BasicProvers.export_rewrites(["pre_FS_DeleteFileDir_System_def"]);
Define `FS_DeleteFileDir_Exception (FS_DeleteFileDir_Exception_parameter_1:System) (FS_DeleteFileDir_Exception_parameter_2:Path)  = (let sys = FS_DeleteFileDir_Exception_parameter_1 and full_path = FS_DeleteFileDir_Exception_parameter_2 in (if (~ (isElemFileStore full_path sys.fileStore)) then 3 else (if (isElemTablePath full_path sys.table) then 4 else (if ((isDirectory (FAPPLY sys.fileStore full_path))  /\ (hasSubFiles sys.fileStore full_path) ) then 9 else 1))))`;
BasicProvers.export_rewrites(["FS_DeleteFileDir_Exception_def"]);
Define `FS_DeleteFileDir_Main (FS_DeleteFileDir_Main_parameter_1:System) (FS_DeleteFileDir_Main_parameter_2:Path)  = (let sys = FS_DeleteFileDir_Main_parameter_1 and full_path = FS_DeleteFileDir_Main_parameter_2 in (if ((full_path  IN (FDOM sys.fileStore) )  /\ (pre_FS_DeleteFileDir_System sys full_path) ) then ((FS_DeleteFileDir_System sys full_path),0) else (sys,(FS_DeleteFileDir_Exception sys full_path))))`;
BasicProvers.export_rewrites(["FS_DeleteFileDir_Main_def"]);
val total = 0;
val success = 0;

(* SUCCESS *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_2 uni_0_var_1.((((inv_FileStore uni_0_var_1)  /\ (?  fileStore.(fileStore  = uni_0_var_1 )) )  /\ (((inv_(Path set) uni_0_var_2)  /\ (?  paths.(paths  = uni_0_var_2 )) )  /\ T ) )  ==> (let paths = uni_0_var_2 in (let fileStore = uni_0_var_1 in ((!  uni_1_var_1.((((uni_1_var_1  IN (FDOM fileStore) )  /\ (?  path.(path  = uni_1_var_1 )) )  /\ T )  ==> (let path = uni_1_var_1 in (((dirName path)  IN paths )  ==> (path  IN paths ) )) ))  ==> (inv_FileStore ((\x y . DRESTRICT y (COMPL x)) paths fileStore)) ))) ))``), VDM_ADDITIONAL_TAC));
val total = total + 1;

(* SUCCESS *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_2 uni_0_var_1.((((inv_System uni_0_var_1)  /\ (?  sys.(sys  = uni_0_var_1 )) )  /\ (((inv_Path uni_0_var_2)  /\ (?  full_path.(full_path  = uni_0_var_2 )) )  /\ T ) )  ==> (let full_path = uni_0_var_2 in (let sys = uni_0_var_1 in ((~ (~ (isElemFileStore full_path sys.fileStore)))  ==> ((~ (isElemTablePath full_path sys.table))  ==> (full_path  IN (FDOM sys.fileStore) ) ) ))) ))``), VDM_ADDITIONAL_TAC));
val total = total + 1;

(* SUCCESS *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_2 uni_0_var_1.((((inv_System uni_0_var_1)  /\ (?  sys.(sys  = uni_0_var_1 )) )  /\ (((inv_Path uni_0_var_2)  /\ (?  full_path.(full_path  = uni_0_var_2 )) )  /\ T ) )  ==> (let full_path = uni_0_var_2 in (let sys = uni_0_var_1 in (((!  uni_1_var_1.((((uni_1_var_1  IN (FRANGE sys.table) )  /\ (?  ofi.(ofi  = uni_1_var_1 )) )  /\ T )  ==> (let ofi = uni_1_var_1 in ((\x y . ~ (x = y)) ofi.path full_path)) ))  /\ (pre_FS_DeleteFileDir_FileStore sys.fileStore {full_path}) )  ==> (inv_System (sys with <|fileStore:=(FS_DeleteFileDir_FileStore sys.fileStore {full_path})|>)) ))) ))``), VDM_ADDITIONAL_TAC));
val total = total + 1;

(* SUCCESS *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_2 uni_0_var_1.((((inv_System uni_0_var_1)  /\ (?  sys.(sys  = uni_0_var_1 )) )  /\ (((inv_Path uni_0_var_2)  /\ (?  full_path.(full_path  = uni_0_var_2 )) )  /\ T ) )  ==> (let full_path = uni_0_var_2 in (let sys = uni_0_var_1 in (((!  uni_1_var_1.((((uni_1_var_1  IN (FRANGE sys.table) )  /\ (?  ofi.(ofi  = uni_1_var_1 )) )  /\ T )  ==> (let ofi = uni_1_var_1 in ((\x y . ~ (x = y)) ofi.path full_path)) ))  /\ (pre_FS_DeleteFileDir_FileStore sys.fileStore {full_path}) )  ==> (pre_FS_DeleteFileDir_FileStore sys.fileStore {full_path}) ))) ))``), VDM_ADDITIONAL_TAC));
val total = total + 1;

(* SUCCESS *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_2 uni_0_var_1.((((inv_System uni_0_var_1)  /\ (?  sys.(sys  = uni_0_var_1 )) )  /\ (((inv_Path uni_0_var_2)  /\ (?  full_path.(full_path  = uni_0_var_2 )) )  /\ T ) )  ==> (let full_path = uni_0_var_2 in (let sys = uni_0_var_1 in (((full_path  IN (FDOM sys.fileStore) )  /\ (pre_FS_DeleteFileDir_System sys full_path) )  ==> (pre_FS_DeleteFileDir_System sys full_path) ))) ))``), VDM_ADDITIONAL_TAC));
val total = total + 1;

(* SUCCESS *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_1.((((inv_(FileName list) uni_0_var_1)  /\ (?  S.(S  = uni_0_var_1 )) )  /\ T )  ==> (let S = uni_0_var_1 in ((~ ((LENGTH S)  = 0 ))  ==> ((\x y . ~ (x = y)) S []) )) ))``), VDM_ADDITIONAL_TAC));
val total = total + 1;

(* SUCCESS *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_1.((((inv_(FileName list) uni_0_var_1)  /\ (?  S.(S  = uni_0_var_1 )) )  /\ T )  ==> (let S = uni_0_var_1 in ((~ ((LENGTH S)  = 0 ))  ==> (let h = (HD S) in ((\x y . ~ (x = y)) S [])) )) ))``), VDM_ADDITIONAL_TAC));
val total = total + 1;

(* taking to long... *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list),
``(!uni_0_var_1. 
   ((((inv_File uni_0_var_1) /\ (?file. (file = uni_0_var_1 ))) /\ T) 
    ==> (let file = uni_0_var_1 and (BList cont) = uni_0_var_1.contents in
	    (((\x y . ~ (x = y)) (LENGTH cont) 0)  ==> ((\x y . ~ (x = y)) cont []) )) ))
``), VDM_ADDITIONAL_TAC));
(*
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_1.((((inv_File uni_0_var_1)  /\ (?  file.(file  = uni_0_var_1 )) )  /\ T )  ==> (let file = uni_0_var_1 in (((\x y . ~ (x = y)) (LENGTH file.contents) 0)  ==> ((\x y . ~ (x = y)) file.contents []) )) ))``), VDM_ADDITIONAL_TAC));
*)
val total = total + 1;

(* taking to long... *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), 
``(!uni_0_var_1. 
   ((((inv_Path uni_0_var_1) /\ (?full_path. (full_path = uni_0_var_1))) /\ T)
    ==> (let full_path = uni_0_var_1 and (AList fileNames) = full_path in
	    (inv_Path (if ((full_path = RootQuoteLiteral) \/ ((LENGTH fileNames) = 1)) 
		           then RootQuoteLiteral 
				   else AList (blast fileNames))))))
``), VDM_ADDITIONAL_TAC));
(*
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_1.((((inv_Path uni_0_var_1)  /\ (?  full_path.(full_path  = uni_0_var_1 )) )  /\ T )  ==> (let full_path = uni_0_var_1 in (inv_Path (if ((full_path  = RootQuoteLiteral )  \/ ((LENGTH full_path)  = 1 ) ) then RootQuoteLiteral else (let S = full_path in (blast S))))) ))``), VDM_ADDITIONAL_TAC));
*)
val total = total + 1;

(* taking to long... *)
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), 
``(!uni_0_var_1.
   ((((inv_Path uni_0_var_1) /\ (?full_path. (full_path = uni_0_var_1))) /\ T)
    ==> (let full_path = uni_0_var_1 and (AList fileNames) = full_path in
	    ((~ ((full_path = RootQuoteLiteral)  \/ ((LENGTH fileNames)  = 1)))
		 ==> (pre_blast fileNames) )) ))
``), VDM_ADDITIONAL_TAC));
(*
val success = success + boolToInteger(can TAC_PROOF(([]:(term list), ``(!  uni_0_var_1.((((inv_Path uni_0_var_1)  /\ (?  full_path.(full_path  = uni_0_var_1 )) )  /\ T )  ==> (let full_path = uni_0_var_1 in ((~ ((full_path  = RootQuoteLiteral )  \/ ((LENGTH full_path)  = 1 ) ))  ==> (let S = full_path in (pre_blast S)) )) ))``), VDM_ADDITIONAL_TAC));
*)
val total = total + 1;

total;
success;

(* total   = 10
   success = 7  *)
